<?php
	
	list ($channel) = $irc_call_args;
	
	$game = $this->custom_vars->yandere_games[$channel];
	
	$game->had_day = true;
	
	if ($game->had_night)
	{
		// Not the first turn. A night just passed.
		
		$game->turn++;
		
		$guarded = array ();
		$killed = array ();
		$yandere_votes = array ();
		
		foreach ($game->votes as $user_id => $vote_id)
		{
			if ($vote_id === false)
			{
				continue;
			}
			
			switch ($this->custom_vars->yandere_role_actions[$game->players[$user_id]->role])
			{
			case 'guard':
				if (isset ($this->custom_vars->yandere_role_actions) && $this->custom_vars->yandere_role_actions[$game->players[$vote_id]->role] == 'vote')
				{
					$killed[] = $user_id;
				}
				else
				{
					$guarded[] = $vote_id;
				}
				break;
			
			case 'spy':
				$role = $game->players[$vote_id]->role;
				
				$role = isset ($this->custom_vars->yandere_role_appearance[$role]) ? $this->custom_vars->yandere_role_appearance[$role] : $role;
				
				notice($game->players[$user_id]->nick, $game->s.$game->players[$vote_id]->nick.' looks like a '.$this->custom_vars->yandere_role_singulars[$role].'.'.$game->e);
				break;
			
			case 'kill':
				$killed[] = $vote_id;
				break;
			
			case 'vote':
				if (!isset ($yandere_votes[$vote_id]))
				{
					$yandere_votes[$vote_id] = 1;
				}
				else
				{
					$yandere_votes[$vote_id]++;
				}
				break;
			}
			
			if (in_array($game->players[$user_id]->role, $this->custom_vars->yandere_role_single_use))
			{
				$game->players[$user_id]->did_action = true;
			}
		}
		
		if (!empty ($yandere_votes))
		{
			$yandere_pick = null;
			$yandere_max = 0;
			
			foreach ($yandere_votes as $user_id => $num)
			{
				if ($num > $yandere_max)
				{
					$yandere_pick = $user_id;
					$yandere_max = $num;
				}
			}
			
			if (!is_null($yandere_pick))
			{
				$killed[] = $yandere_pick;
			}
		}
		
		$killed = array_unique($killed);
		$killed = array_diff($killed, $guarded);
		
		if (empty ($killed))
		{
			output($channel, $game->s.'The dawn comes, and it seems everyone survived the night.'.$game->e);
		}
		else
		{
			output($channel, $game->s.'Morning comes with the stench of death.'.$game->e);
			
			$yanderes_killed = array ();
			
			foreach ($killed as $key => $user_id)
			{
				sleep(5);
				
				$description = $this->custom_vars->yandere_murder_descriptions[mt_rand(0, count($this->custom_vars->yandere_murder_descriptions) - 1)];
				
				$weapon = $this->custom_vars->yandere_weapons[mt_rand(0, count($this->custom_vars->yandere_weapons) - 1)];
				
				$role = $game->blind_roles ? '' : ', a '.$this->custom_vars->yandere_role_singulars[$game->players[$user_id]->role].',';
				
				output($channel, $game->s.$game->players[$user_id]->nick.$role.' '.$description.' '.$weapon.'.'.$game->e);
				
				if ($game->players[$user_id]->action == 'vote')
				{
					$yanderes_killed[] = $game->players[$user_id]->nick;
				}
				
				$killed[$key] = $game->players[$user_id]->nick;
				
				unset ($game->players[$user_id]);
			}
			
			sleep(5);
		}
		
		if (call('yandere/check-game-over', $channel))
		{
			return;
		}
	}
	
	$game->votes = array ();
	
	// Schedule a reminder to vote or abstain.
	
	if ($game->turn <= 2)
	{
		$this->schedule_event(time() + 300 * (floor($game->turn / 2) + 1), array ('yandere/day-reminder', $channel, $game->start_time, $game->turn));
	}
	
	// Schedule the sunset.
	
	$this->schedule_event(time() + 1800, array ('yandere/day-sunset', $channel, $game->start_time, $game->turn));
	
	// Status.
	
	$players = array ();
	
	foreach ($game->players as $player)
	{
		$players[] = $player->nick;
	}
	
	// Give voice to all players.
	
	call('yandere/give-voice', $channel);
	
	output($channel, $game->s.'Current players: '.implode_comma_series($players).'.'.$game->e);
	
?>
